﻿////////////////////////////////////////////
//

//
// << 작성목적 >>
// Cubrid DB(http://www.cubrid.com)에 Procedure, Function을 위해 제작된 java 파일을 
// 손쉽게 Cubrid로 등록할 수 있도록 제작된 작은 유틸리티입니다. CUBRID Manager에 이 기능이 삽입되기 
// 전까지 열심히 추가작업을 해보겠습니다.
//  

// 
// << 개발환경 >>
// OS : Windows XP Pro
// TOOL : VS .NET 2005 Standard

//
// << 주의사항 >>
// CUBRID DB와 JAVA SDK가 설치된 곳에서 실행해 주시기 바랍니다.
// 현재 정상적으로 등록되었는지 여부는 Cubrid DB에서 직접 확인하시기 바랍니다.
// (이 기능은 CUBRID DB의 다음 버젼에 지원이 될 예정이라고 합니다.)


// 
// << 개발자 >>
// Ji hyun,LEE(ljh6341@gmail.com) 19th, Oct, 2007 (Fri)

// 
// << 라이센스 >>
// Free License입니다.
// 누구나 수정, 재사용이 가능합니다.
// 버그수정, 기능추가시 개발자에게 메일로 알려주시면, 좀 더 좋은 코드를 공유할 수 있는 계기가 됩니다.
// 

// Spacial Thanks :
// 코드 공개를 허락해주신 (주)엘엔케이로직코리아(http://logickorea.co.kr)에 감사드립니다.

// History 
//
//
// 2007. 10. 19 : DB Name, JAVA코드 등록, Method등록 코드를 삽입하면 , 코드 컴파일, 로드, 등록을 순서대로 진행하면 됩니다.
// 
//
////////////////////////////////////////////



using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Utility_Cubrid
{
    public partial class Form1 : Form
    {
        public ProcessStartInfo psInfo;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //  Command창을 사용하기 위한 기본 정보 설정
            psInfo = new ProcessStartInfo("cmd");
            psInfo.RedirectStandardError = true;
            psInfo.RedirectStandardInput = true;
            psInfo.RedirectStandardOutput = true;
            psInfo.CreateNoWindow = true;
            psInfo.UseShellExecute = false;

        }

        private void printResult(StreamReader _output)
        {
            String txt = _output.ReadToEnd();
            ctlTxtBox_ResultWindow.AppendText(txt);
        }

        private bool checkError(StreamReader _errOutput)
        {
            String txt = _errOutput.ReadToEnd();
            if (txt != "")
            {
                ctlTxtBox_ResultWindow.AppendText(txt);
                ctlTxtBox_ResultWindow.AppendText("==================================");
                return true;
            }
            ctlTxtBox_ResultWindow.AppendText("==================================");
            return false;
        }

        private bool execCommand(String _inputText, Process _proc, StreamReader _output, StreamReader _errOutput)
        {
            StreamWriter cmdInput = _proc.StandardInput;
            cmdInput.AutoFlush = true;
            cmdInput.WriteLine(_inputText);
            cmdInput.Close();
            printResult(_output);
            return checkError(_errOutput);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if(openFileDlg_Java.ShowDialog() == DialogResult.OK)
            {
                ctlTextBox_JavaFileName.Text = openFileDlg_Java.FileName;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (ctlTextBox_JavaFileName.Text == "" || !ctlTextBox_JavaFileName.Text.Contains(".java") )
            {
                MessageBox.Show( "JAVA 원본 파일에 문제가 있습니다.");
                return;
            }
            //  cmd창을 위한 프로세스를 만든다.
            Process cmdProc = new Process();
            cmdProc.StartInfo = psInfo;
            cmdProc.Start();

            StreamReader cmdOutput = cmdProc.StandardOutput;
            StreamReader errOutput = cmdProc.StandardError;

            //  자바 컴파일러로 컴파일한다.
            String str = "javac " + ctlTextBox_JavaFileName.Text;
            if (execCommand(str, cmdProc, cmdOutput, errOutput))
            {
                return;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (ctlTextBox_JavaFileName.Text == "" || !ctlTextBox_JavaFileName.Text.Contains(".java"))
            {
                MessageBox.Show("JAVA 원본 파일에 문제가 있습니다.");
                return;
            }
            //  class 파일이 있는지 검사

            //  cmd창을 위한 프로세스를 만든다.
            Process cmdProc = new Process();
            cmdProc.StartInfo = psInfo;
            cmdProc.Start();

            StreamReader cmdOutput = cmdProc.StandardOutput;
            StreamReader errOutput = cmdProc.StandardError;

            //  class파일이 생겼다면.. 레이큐브 DB에 로드한다.
            String filename =ctlTextBox_JavaFileName.Text.Replace(".java", ".class");
            String str = "loadjava.exe -y " + ctlTextBox_DBName.Text + " " + filename;
            if (execCommand(str, cmdProc, cmdOutput, errOutput))
            {
                return;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (ctlTxtBox_RegScript.Text == "" )
            {
                MessageBox.Show("Cubrid에 등록할 스크립트가 지정되지 않았습니다.");
                return;
            }

            //  cmd창을 위한 프로세스를 만든다.
            Process cmdProc = new Process();
            ProcessStartInfo psInfo_sqlx;
            psInfo_sqlx = new ProcessStartInfo("sqlx");
            psInfo_sqlx.Arguments = ctlTextBox_DBName.Text;
            psInfo_sqlx.RedirectStandardError = true;
            psInfo_sqlx.RedirectStandardInput = true;
            psInfo_sqlx.RedirectStandardOutput = true;
            psInfo_sqlx.CreateNoWindow = true;
            psInfo_sqlx.UseShellExecute = false;

            cmdProc.StartInfo = psInfo_sqlx;
            cmdProc.Start();

            StreamReader cmdOutput = cmdProc.StandardOutput;
            StreamReader errOutput = cmdProc.StandardError;

            //  로드된 SP를 등록시킨다.
            StreamWriter cmdInput = cmdProc.StandardInput;
            cmdInput.AutoFlush = true;

            cmdInput.WriteLine(ctlTxtBox_RegScript.Text + ";");
            cmdInput.Close();
            printResult(cmdOutput);
        }
    }
}